package com.inteligr8.alfresco.activiti;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;

import com.inteligr8.rs.ClientCxfConfiguration;
import com.inteligr8.rs.ClientJerseyConfiguration;

/**
 * This class provides a POJO &amp; Spring-based implementation of the
 * ClientConfiguration interface.  You can use it outside of the Spring
 * context, but you will need the spring-context and spring-beans libraries in
 * your non-Spring application.
 * 
 * @author brian@inteligr8.com
 */
@Configuration
@ComponentScan
public class ApsClientConfiguration implements ClientCxfConfiguration, ClientJerseyConfiguration {

	@Value("${process.service.baseUrl:http://localhost:8080/activiti-app}")
	private String baseUrl;

	@Value("${process.service.security.basicAuth.username:admin@app.activiti.com}")
	private String basicAuthUsername;

	@Value("${process.service.security.basicAuth.password:admin}")
	private String basicAuthPassword;

	@Value("${process.service.security.bearerToken:#{null}}")
	private String bearerToken;

	@Value("${process.service.security.oauth.tokenUrl:#{null}}")
	private String oAuthTokenUrl;

	@Value("${process.service.security.oauth.clientId:#{null}}")
	private String oAuthClientId;

	@Value("${process.service.security.oauth.clientSecret:#{null}}")
	private String oAuthClientSecret;

	@Value("${process.service.security.oauth.authCode:#{null}}")
	private String oAuthAuthCode;

	@Value("${process.service.security.oauth.authRedirectUri:#{null}}")
	private String oAuthAuthRedirectUri;

	@Value("${process.service.security.oauth.grantUsername:#{null}}")
	private String oAuthUsername;

	@Value("${process.service.security.oauth.grantPassword:#{null}}")
	private String oAuthPassword;

	@Value("${process.service.cxf.defaultBusEnabled:true}")
	private boolean defaultBusEnabled;
	
	@Value("${process.service.jersey.putBodyRequired:true}")
	private boolean putBodyRequired;

	public String getBaseUrl() {
		return this.baseUrl;
	}
	
	public void setBaseUrl(String baseUrl) {
		this.baseUrl = baseUrl;
	}
	
	public String getBasicAuthUsername() {
		return this.basicAuthUsername;
	}

	public void setBasicAuthUsername(String basicAuthUsername) {
		this.basicAuthUsername = basicAuthUsername;
	}
	
	public String getBasicAuthPassword() {
		return this.basicAuthPassword;
	}

	public void setBasicAuthPassword(String basicAuthPassword) {
		this.basicAuthPassword = basicAuthPassword;
	}
	
	public String getBearerToken() {
		return this.bearerToken;
	}

	public void setBearerToken(String bearerToken) {
		this.bearerToken = bearerToken;
	}
	
	public String getOAuthTokenUrl() {
		return this.oAuthTokenUrl;
	}

	public void setOAuthTokenUrl(String oAuthTokenUrl) {
		this.oAuthTokenUrl = oAuthTokenUrl;
	}
	
	public String getOAuthClientId() {
		return this.oAuthClientId;
	}

	public void setOAuthClientId(String oAuthClientId) {
		this.oAuthClientId = oAuthClientId;
	}
	
	public String getOAuthClientSecret() {
		return this.oAuthClientSecret;
	}

	public void setOAuthClientSecret(String oAuthClientSecret) {
		this.oAuthClientSecret = oAuthClientSecret;
	}
	
	public String getOAuthAuthCode() {
		return this.oAuthAuthCode;
	}

	public void setOAuthAuthCode(String oAuthAuthCode) {
		this.oAuthAuthCode = oAuthAuthCode;
	}
	
	public String getOAuthAuthRedirectUri() {
		return this.oAuthAuthRedirectUri;
	}

	public void setOAuthAuthRedirectUri(String oAuthAuthRedirectUri) {
		this.oAuthAuthRedirectUri = oAuthAuthRedirectUri;
	}
	
	public String getOAuthUsername() {
		return this.oAuthUsername;
	}

	public void setOAuthUsername(String oAuthUsername) {
		this.oAuthUsername = oAuthUsername;
	}
	
	public String getOAuthPassword() {
		return this.oAuthPassword;
	}

	public void setOAuthPassword(String oAuthPassword) {
		this.oAuthPassword = oAuthPassword;
	}
	
	public boolean isDefaultBusEnabled() {
		return this.defaultBusEnabled;
	}

	public void setDefaultBusEnabled(boolean defaultBusEnabled) {
		this.defaultBusEnabled = defaultBusEnabled;
	}
	
	public boolean isPutBodyRequired() {
		return this.putBodyRequired;
	}

	public void setPutBodyRequired(boolean putBodyRequired) {
		this.putBodyRequired = putBodyRequired;
	}

}
