package com.inteligr8.alfresco.activiti;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import com.inteligr8.alfresco.activiti.api.AppDefinitionsJerseyApi;
import com.inteligr8.rs.AuthorizationFilter;
import com.inteligr8.rs.Client;
import com.inteligr8.rs.ClientConfiguration;

/**
 * This class provides the Jersey client to the JAX-RS API for the APS Public
 * ReST API.
 * 
 * @author brian@inteligr8.com
 */
@Component("aps.api.jersey")
@Lazy
public class ApsPublicRestApiJerseyImpl extends ApsPublicRestApi {
	
	@Autowired
	private ApsClientJerseyImpl client;
	
	/**
	 * This constructor is for Spring use
	 */
	protected ApsPublicRestApiJerseyImpl() {
	}

	/**
	 * This constructor is for POJO use
	 */
	public ApsPublicRestApiJerseyImpl(ApsClientJerseyImpl client) {
		this.client = client;
	}
	
	@Override
	ClientConfiguration getConfig() {
		return this.client.getConfig();
	}
	
	@Override
	Client getClient() {
		return this.client;
	}
	
	public AppDefinitionsJerseyApi getAppDefinitionsJerseyApi() {
		return this.getApi(AppDefinitionsJerseyApi.class);
	}
	
	public AppDefinitionsJerseyApi getAppDefinitionsJerseyApi(AuthorizationFilter authFilter) {
		return this.getApi(authFilter, AppDefinitionsJerseyApi.class);
	}

}
