
package com.inteligr8.alfresco.activiti.api;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;

import com.inteligr8.alfresco.activiti.model.ResultListDataRepresentation;

@Path("/api/enterprise/models")
public interface ModelsApi {
	
	enum ModelType {
		Process(0),
		Form(2),
		App(3);
		
		private int id;
		private ModelType(int id) {
			this.id = id;
		}
		
		public int getId() {
			return this.id;
		}
	}

    @GET
    @Produces({ "application/json" })
    public ResultListDataRepresentation get(
    		@QueryParam("filter") String filter,
    		@QueryParam("sort") String sort,
    		@QueryParam("modelType") Integer modelType,
    		@QueryParam("referenceId") Long referenceId);

}
