
package com.inteligr8.alfresco.activiti.api;

import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;

import com.inteligr8.alfresco.activiti.model.Task;
import com.inteligr8.alfresco.activiti.model.TaskUpdate;
import com.inteligr8.alfresco.activiti.model.Variable;

@Path("/api/enterprise/tasks")
public interface TasksApi {

    @PUT
    @Path("{taskId}")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    public Task update(@PathParam("taskId") String taskId, TaskUpdate taskUpdate);
    
    @GET
    @Path("{taskId}/variables")
    @Produces({ "application/json" })
    List<Variable> getVariables(@PathParam("taskId") String taskId, @QueryParam("scope") String scope);
    
    @PUT
    @Path("{taskId}/variables")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    List<Variable> setVariables(@PathParam("taskId") String taskId, List<Variable> variables);
    
    @GET
    @Path("{taskId}/variables/{variableName}")
    @Produces({ "application/json" })
    Variable getVariable(@PathParam("taskId") String taskId, @PathParam("variableName") String variableName, @QueryParam("scope") String scope);
    
    @PUT
    @Path("{taskId}/variables/{variableName}")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    Variable setVariable(@PathParam("taskId") String taskId, @PathParam("variableName") String variableName, Variable variable);
    
    @DELETE
    @Path("{taskId}/variables/{variableName}")
    void deleteVariable(@PathParam("taskId") String taskId, @PathParam("variableName") String variableName, @QueryParam("scope") String scope);

}
