package com.inteligr8.alfresco.activiti;

import java.util.List;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.condition.EnabledIf;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.test.context.TestPropertySource;
import org.springframework.test.context.junit.jupiter.SpringJUnitConfig;

import com.inteligr8.alfresco.activiti.model.Tenant;
import com.inteligr8.rs.ClientConfiguration;

@TestPropertySource(locations = {"/local.properties"})
@SpringJUnitConfig(classes = {ApsClientConfiguration.class, ApsPublicRestApiJerseyImpl.class, ApsClientJerseyImpl.class})
public class ArrayResponseUnitTest extends ConditionalIT {
	
	@Autowired
	@Qualifier("aps.api.jersey")
	private ApsPublicRestApi client;
	
	@Override
	public ClientConfiguration getConfiguration() {
		return this.client.getConfig();
	}
	
	@Test
	@EnabledIf("hostExists")
	public void testTenants() {
		List<Tenant> objs = this.client.getAdminApi().getTenants();
		
		Assertions.assertNotNull(objs);
	}

}
